library ieee;
use ieee.std_logic_1164.all;

entity FeuxCirculation is
   port (CVen, HorlEn: in std_logic; PR, TR, PJ, TJ, PV, TV: out std_logic);
end entity FeuxCirculation;

architecture ComportementFeuxCirculation of FeuxCirculation is

component DecodeurEtat is
   port (G0, G1: in std_logic; S1, S2, S3, S4: out std_logic);
end component DecodeurEtat;

component LogiqueSequentielle is
   port (CV, ML, MC, Horl: in std_logic; G0, G1: inout std_logic);
end component LogiqueSequentielle;

component CircuitsMinuteries is
   port (DeclLong, DeclCourt, Horl: in std_logic; MC, ML: buffer std_logic);
end component CircuitsMinuteries;

component DiviseFreq is
   port (HorlEn: in std_logic; HorlSor: buffer std_logic);
end component DiviseFreq;

signal Feu1, Feu2, Feu3, Feu4, Gray0, Gray1: std_logic;
signal TempsLong, TempsCourt, MLen, MCen, Horloge: std_logic;
begin
   PR <= Feu3 or Feu4;
   TR <= Feu2 or Feu1;
   PJ <= Feu2;
   TJ <= Feu4;
   PV <= Feu1;
   TV <= Feu3;
   TempsLong <= Feu1 or Feu3;
   TempsCourt <= not(Feu1 or Feu3);

DE: DecodeurEtat port map (G0 => Gray0, G1 => Gray1, S1 => Feu1, S2 => Feu2, S3 => Feu3, S4 => Feu4);
LS: LogiqueSequentielle port map (CV => CVen, ML => MLen, MC => MCen, Horl => Horloge, G0 => Gray0, G1 => Gray1);
CM: CircuitsMinuteries port map (DeclLong => TempsLong, DeclCourt => TempsCourt, Horl => Horloge, MC => MCen, ML => MLen);
DF: DiviseFreq port map (HorlEn => HorlEn, HorlSor => Horloge);

end architecture ComportementFeuxCirculation;