library ieee;
use ieee.std_logic_1164.all;

entity CompteurDecadeSyncQuatreBits is
   port (Horloge: in std_logic; Q0, Q1, Q2, Q3: inout std_logic);
end entity CompteurDecadeSyncQuatreBits;

architecture FonctionLogique of CompteurDecadeSyncQuatreBits is

component BascJK is
   port (J, K, Horloge: in std_logic; Q: out std_logic);
end component BascJK;

signal J1, J2, J3: std_logic;
begin
   J1 <= Q0 and not Q3;
   J2 <= Q1 and Q0;
   J3 <= (Q2 and J2) or (Q0 and Q3);
   BASC0: BascJK port map (J => '1', K => '1', Horloge => Horloge, Q => Q0);
   BASC1: BascJK port map (J => J1, K => J1, Horloge => Horloge, Q => Q1);
   BASC2: BascJK port map (J => J2, K => J2, Horloge => Horloge, Q => Q2);
   BASC3: BascJK port map (J => J3, K => J3, Horloge => Horloge, Q => Q3);
end architecture FonctionLogique;